#define AD(x) x, elemsof(x) /* Array Description */

/**************** IPsec (quick mode) SA database ****************/


/* arrays of transforms, each in in preference order */

static struct db_trans espa_trans_tunnel2[] = {
    { ESP_3DES, AD(espsha1_attr_tunnel) },
    { ESP_3DES, AD(espmd5_attr_tunnel) },
    { ESP_DES, AD(espsha1_attr_tunnel) },
    { ESP_DES, AD(espmd5_attr_tunnel) },
    };

static struct db_trans espa_trans_transport2[] = {
    { ESP_3DES, AD(espsha1_attr_transport) },
    { ESP_3DES, AD(espmd5_attr_transport) },
    { ESP_DES, AD(espsha1_attr_transport) },
    { ESP_DES, AD(espmd5_attr_transport) },
    };

static struct db_trans esp_trans_tunnel2[] = {
    { ESP_3DES, AD(esp_attr_tunnel) },
    { ESP_DES, AD(esp_attr_tunnel) },
    };

static struct db_trans esp_trans_transport2[] = {
    { ESP_3DES, AD(esp_attr_transport) },
    { ESP_DES, AD(esp_attr_transport) },
    };

#ifdef SUPPORT_ESP_NULL
static struct db_trans espnull_trans_tunnel2[] = {
    { ESP_NULL, AD(espsha1_attr_tunnel) },
    { ESP_NULL, AD(espmd5_attr_tunnel) },
    };

static struct db_trans espnull_trans_transport2[] = {
    { ESP_NULL, AD(espsha1_attr_transport) },
    { ESP_NULL, AD(espmd5_attr_transport) },
    };
#endif

static struct db_trans ah_trans_tunnel2[] = {
    { AH_SHA, AD(ah_HMAC_SHA1_attr_tunnel) },
    { AH_SHA, AD(ah_HMAC_MD5_attr_tunnel) },
    };

static struct db_trans ah_trans_transport2[] = {
    { AH_SHA, AD(ah_HMAC_SHA1_attr_transport) },
    { AH_SHA, AD(ah_HMAC_MD5_attr_transport) },
    };

//
static struct db_prop ah_pc_tunnel2[] = {
    { PROTO_IPSEC_AH, AD(ah_trans_tunnel2) },
    };

static struct db_prop ah_pc_transport2[] = {
    { PROTO_IPSEC_AH, AD(ah_trans_transport2) },
    };

#ifdef SUPPORT_ESP_NULL
static struct db_prop espnull_pc_tunnel2[] = {
    { PROTO_IPSEC_ESP, AD(espnull_trans_tunnel2) },
    };

static struct db_prop espnull_pc_transport2[] = {
    { PROTO_IPSEC_ESP, AD(espnull_trans_transport2) },
    };
#endif

static struct db_prop esp_pc_tunnel2[] = {
    { PROTO_IPSEC_ESP, AD(espa_trans_tunnel2) },
    };

static struct db_prop esp_pc_transport2[] = {
    { PROTO_IPSEC_ESP, AD(espa_trans_transport2) },
    };

static struct db_prop ah_esp_pc_tunnel2[] = {
    { PROTO_IPSEC_AH, AD(ah_trans_tunnel2) },
    { PROTO_IPSEC_ESP, AD(esp_trans_tunnel2) },
    };

static struct db_prop ah_esp_pc_transport2[] = {
    { PROTO_IPSEC_AH, AD(ah_trans_transport2) },
    { PROTO_IPSEC_ESP, AD(esp_trans_transport2) },
    };


static struct db_prop_conj ah_tunnel_props2[] =
    { { AD(ah_pc_tunnel2) },
#ifdef SUPPORT_ESP_NULL
      { AD(espnull_pc_tunnel2) }
#endif
    };

static struct db_prop_conj ah_transport_props2[] =
    { { AD(ah_pc_transport2) },
#ifdef SUPPORT_ESP_NULL
      { AD(espnull_pc_transport2) }
#endif
    };

static struct db_prop_conj esp_tunnel_props2[] =
    { { AD(esp_pc_tunnel2) } };

static struct db_prop_conj esp_transport_props2[] =
    { { AD(esp_pc_transport2) } };

static struct db_prop_conj ah_esp_tunnel_props2[] =
    { { AD(ah_esp_pc_tunnel2) } };

static struct db_prop_conj ah_esp_transport_props2[] =
    { { AD(ah_esp_pc_transport2) } };

struct db_sa ipsec_sadb2[1 << 3] = {
    { NULL, 0 },
    { AD(esp_transport_props2) },
    { AD(ah_transport_props2) },
    { AD(ah_esp_transport_props2) },
    { NULL, 0 },
    { AD(esp_tunnel_props2) },
    { AD(ah_tunnel_props2) },
    { AD(ah_esp_tunnel_props2) },
    };
#undef AD

